;#################################################################################
; pwm_and_timer.asm (has to be @ cseg)
;#################################################################################

pwm_and_timer_init:
      
    ;
    ; Timer 1 einstellen
    ;
    ; Modus 14:
    ;    Fast PWM, Top von ICR1
    ;
    ;     WGM13    WGM12   WGM11    WGM10
    ;      1        1       1        0
    ;
    ;    Timer Vorteiler: 256
    ;     CS12     CS11    CS10
    ;      1        0       0
    ;
    ; Steuerung des Ausgangsport: Set at BOTTOM, Clear at match
    ;     COM1A1   COM1A0
    ;      1        0
    ;
 
    ldi      temp, 1<<COM1B1 | 1<<COM1A1 | 1<<WGM11
    out      TCCR1A, temp
 
    ldi      temp, 1<<WGM13 | 1<<WGM12 | 1<<CS10
    out      TCCR1B, temp
 
    ;
    ; den Endwert (TOP) fr den Zhler setzen
    ; der Zhler zhlt bis zu diesem Wert
    ;
    ldi      temp, 0x6f
    out      ICR1H, temp
    ldi      temp, 0xff
    out      ICR1L, temp
 
    ;
    ; der Compare Wert
    ; Wenn der Zhler diesen Wert erreicht, wird mit
    ; obiger Konfiguration der OC1A Ausgang abgeschaltet
    ; Sobald der Zhler wieder bei 0 startet, wird der
    ; Ausgang wieder auf 1 gesetzt
    ;
    ldi      temp, 0x37
    out      OCR1AH, temp
    ldi      temp, 0xff
    out      OCR1AL, temp

    ldi      temp, 0x37
    out      OCR1BH, temp
    ldi      temp, 0xff
    out      OCR1BL, temp
 
    ; Den Pin OC1A zu guter letzt noch auf Ausgang schalten
    ldi      temp, 0xff
    out      DDRD, temp

   ; timer0 einstellen
   ldi     temp, 1<<CS02     ; CS02 setzen: Teiler 256 -> bei 16Mhz alle 0.004096 sec = 4096 s
   out     TCCR0, temp
 
   ldi     temp, 0b00000001      ; TOIE0: Interrupt bei Timer Overflow
   out     TIMSK, temp

   
ret

pwm_mid:
in r2,ICR1L
in r3,ICR1H
asr r3
ror r2
out OCR1AH,r3
out OCR1AL,r2
ret

pwm_inc:
in r2,OCR1AL
in r3,OCR1AH
ldi r16,1
ldi r17,0
add r2,r16
adc r3,r17

out OCR1AH,r3
out OCR1AL,r2
ret

pwm_dec:
in r2,OCR1AL
in r3,OCR1AH
ldi r16,1
ldi r17,0
sub r2,r16
sbc r3,r17

out OCR1AH,r3
out OCR1AL,r2
ret

pwm_set_high:
ldi r16,0x00
ldi r17,0x14
out OCR1AH,r17
out OCR1AL,r16
ret
pwm_set_low:
ldi r16,0x00
ldi r17,0x00
out OCR1AH,r17
out OCR1AL,r16
ret














;#################################################################################
; pwm_and_timer.asm
;#################################################################################
